<?php
// Rutas del archivos
$TOTALLASTMONTHFILE = '/var/www/html/script/rainlastmonthtotal.txt';
$TOTALLASTMONTHFILER = file_get_contents($TOTALLASTMONTHFILE);
$archivoRegistro = '/var/www/html/script/rainlastmonthcon.txt';

// Directorio donde se encuentran los archivos
$directory = '/var/www/html/Reports/';

// Obtener el año actual y el mes actual
$dia = date('d');
$year = date("y");
$month = date("n");
//$dia = "19"; //TEST 
//$year ="24";//TEST
//$month = "3";//TEST
echo "Dia, año y mes:". "<br>";
echo $dia . "<br>";
echo $year . "<br>";
echo $month . "<br>";

// Calcular el mes anterior
if ($month == 1) {
    $previous_month = 12; // Si es enero, el mes anterior es diciembre del año anterior
    $previous_year = $year - 1; // Obtener los últimos dos dígitos del año anterior
} else {
    $previous_month = ($month - 1 < 10) ? $month - 1 : ($month - 1); // Si es necesario, ajustar el mes sin cero delante
    $previous_year = $year;
}

// Array asociativo para mapear números de mes a nombres de mes
$meses = array(
    "1" => "enero",
    "2" => "febrero",
    "3" => "marzo",
    "4" => "abril",
    "5" => "mayo",
    "6" => "junio",
    "7" => "julio",
    "8" => "agosto",
    "9" => "septiembre",
    "10" => "octubre",
    "11" => "noviembre",
    "12" => "diciembre"
);
// Nombre del mes anterior
$nombre_mes_anterior = $meses[$previous_month];

 

echo  "Año y mes anterior:"."<br>";
echo $previous_year . "<br>";
echo $previous_month . "<br>";

// Nombre del archivo del mes anterior
$archivo_anterior = $directory . 'NOAAYR' .  '20'. $previous_year . '.txt';

echo "El archivo que se está procesando es: " . $archivo_anterior . "<br>";

// Verificar si el archivo existe antes de intentar acceder a su contenido
if (file_exists($archivo_anterior)) {
    // Obtener las líneas del archivo
    $lineas = file($archivo_anterior, FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);

    // Valor de precipitación para el mes de diciembre (12)
    $valor_precipitacion = null;

    // Bandera para determinar si estamos en el bloque de precipitación
    $en_bloque_precipitacion = false;

    // Contenido de la sección deseada
    $contenido_seccion_deseada = '';

    // Iterar a través de las líneas para extraer la sección deseada
    foreach ($lineas as $linea) {
        // Iniciar la extracción cuando encontramos la línea que contiene "Precipitation (mm)"
        if (strpos($linea, 'Precipitation (mm)') !== false) {
            $en_bloque_precipitacion = true;
        }

        // Agregar la línea al contenido de la sección si estamos dentro de ella
        if ($en_bloque_precipitacion) {
            $contenido_seccion_deseada .= $linea . "\n";
        }

        // Detener la extracción cuando encontramos la línea que contiene "Wind Speed"
        if (strpos($linea, 'Wind Speed') !== false) {
            break;
        }
    }

    /// Mostrar el contenido de la sección manteniendo el formato
echo "<pre>" . htmlspecialchars($contenido_seccion_deseada) . "</pre>";

 
    // Mostrar el contenido del archivo manteniendo el formato
     
} else {
    echo "El archivo no existe";
}
 

// Patrón que busca el valor de precipitación para el año y mes proporcionados
//$patron = "/\b$previous_year  $previous_month (\d+,\d+)\b/";
$patron = "/\b$previous_year\s+$previous_month\s+(\d+,\d+)\b/";
// Buscar coincidencia en el texto usando la expresión regular
if (preg_match($patron, $contenido_seccion_deseada, $matches)) {
    $valor_precipitacion = $matches[1];
$valor_precipitacion = str_replace(',', '.', $valor_precipitacion);
$valor_precipitacion = str_replace(' ', '', $valor_precipitacion);

   echo "El valor de precipitación para el mes de ", $nombre_mes_anterior . " es: " . $valor_precipitacion . " mm";
} else {
    echo "No se encontró ningún valor de precipitación para el mes anterior en el texto.";
}


echo "<br>";

$ultimaEjecucion = file_get_contents($archivoRegistro);

if ($ultimaEjecucion !== $dia) {
    // Ejecuta tu código aquí
    $ejecutado = "0";
    echo 'El script aun no se habia ejecutado hoy.<br>';
    // Actualiza la fecha de la última ejecución
    file_put_contents($archivoRegistro, $dia) ."<br>";
} else {
    echo 'El script ya se ejecutó hoy.<br>';
    $ejecutado = "1";
}


// Verificar si es el primer día del mes y si lo es y el script no se ha ejecutado actualiza mes anterior
if (//$dia === "1" && //omitimos dia
$ejecutado === "0") {
	  // Codigo a ejecutar 
	    echo '<a style="font-weight: bold;">Actualizando cantidad mes anterior</a><br>';
    	echo "<br>" .$valor_precipitacion . "<br>" ;
 	   file_put_contents($TOTALLASTMONTHFILE, $valor_precipitacion);
	  } else {
        echo "No es dia 1 o ya se ha ejecutado el script<br>";
		   
}


?>

 